#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"


static asm char TwGfxOpenNoSignV2 (void *p, void *q);

typedef struct TwGfxType* TwGfxHandle;
typedef struct TwGfxSurfaceType* TwGfxSurfaceHandle;

/* These declarations are for C */
typedef struct TwGfxType TwGfxType;
typedef struct TwGfxSurfaceType TwGfxSurfaceType;

typedef struct TwGfxInfoType {
  Int32 size;                                   /* caller MUST set this to sizeof(TwGfxInfoType) */

  Int32 displayWidth, displayHeight;            /* current dimensions of display */
  Int32 displayRowBytes;                        /* byte width of entire row */
  Int32 displayPixelFormat;                     /* format of display */

  Int32 freeAcceleratorMemory;                  /* free accelerator memory */
  Int32 totalAcceleratorMemory;                 /* total accelerator memory */
} TwGfxInfoType;

unsigned long ARMlet_Main(const void *emulStateP, void *userData68KP, Call68KFuncType *call68KFuncP)
{
	void **myData = (void **) userData68KP;
	
	TwGfxHandle c;
	TwGfxInfoType d;
	
//	void *a = (void *) ByteSwap32(myData[0]);
	UInt8 *b = (UInt8 *) ByteSwap32(myData[1]);
	
	long res, i;
	
	d.size = sizeof(d);
	
//	return TwGfxOpenNoSignV2((void *) ByteSwap32(myData[0]), (void *) ByteSwap32(myData[1]));
//	return TwGfxOpenNoSignV2(a, b);
	res = TwGfxOpenNoSignV2(&c, &d);
	myData[0] = (void *) ByteSwap32(c);
	for (i=0; i<sizeof(d); i+=4)
	{
		b[i+0] = ((UInt8 *) &d)[i+3];
		b[i+1] = ((UInt8 *) &d)[i+2];
		b[i+2] = ((UInt8 *) &d)[i+1];
		b[i+3] = ((UInt8 *) &d)[i+0];
	}

	return res;
}

// Using TwGfx without signing (thanks Squidge!):
static asm char TwGfxOpenNoSignV2 (void *p, void *q)
{
	stmfd sp!, {r4-r11,lr}
	ldr r9, [r9]
	ldr r9, [r9]
	sub sp, sp, #0x24
	mov r6, r0
	mov r7, r1
	ldr pc, =0x200995F0
}

