#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"
//#include "AppRsc.h"
#ifdef __PACE__  
#include "PACEInterface.h"
#else
#include "palmos5.h"
#endif


#include "PNOMain.h"

#include "unzip.h"

#include "timidity.h"

// from doomdef.h
typedef enum
{
    sk_baby,
    sk_easy,
    sk_medium,
    sk_hard,
    sk_nightmare
} skill_t;

// from doomtype.h
typedef int boolean;

void Sys_PrintF( char *s, ...);
void Sys_PrintF2( char *s, ...);

UInt32 mStopEmulation=0;

char gpstr[256]; //used for general debugging purpose
char wad_filename[256];
char pwad_filename[256];

extern int		myargc;
extern char**		myargv;


extern int SCREENWIDTH;
extern int SCREENHEIGHT;

extern int g_scr_rotated;
extern int g_music_mode;
int g_rumble;

extern UInt32 n2PlayerRole;
extern UInt32 nSerPortId;
extern UInt32 bSerPortOpened;

extern UInt32 bNetLibOpened;
extern UInt32 gblIPAddress;
extern UInt32 netLibRefNum;
extern UInt32 insocket;
extern UInt32 outsocket;
extern UInt32 gblDoomPort;

UInt32 bDebugFile = 0;

extern boolean nomonsters;
extern boolean respawnparm;
extern boolean deathmatch;
skill_t gblStartSkill = sk_medium;
int gblStartEpisode = 1;
int gblStartMap = 1;


void ClearScreen(void);

unsigned int g_confinput[20];

#include <AdnDebugMgr.h>
unsigned long Run()
{
	UInt32 max, bytes;
	UInt32 result,penDown;
	char *ftrptr;
	int i;
	
//	AdnDebugEnableSet(kAdnEnableDebugIndicator | kAdnEnableFullDebugging | kAdnEnableMasterSwitch);
//	AdnDebugBreak();
		
	FtrGet(CREATORID, FTR_NET_OPEN_ID, (unsigned long*)&bNetLibOpened);
	FtrGet(CREATORID, FTR_NET_IP_ID, (unsigned long*)&gblIPAddress);
	FtrGet(CREATORID, FTR_NET_LIB_ID, (unsigned long*)&netLibRefNum);
	FtrGet(CREATORID, FTR_NET_INSOCK_ID, (unsigned long*)&insocket);
	FtrGet(CREATORID, FTR_NET_OUTSOCK_ID, (unsigned long*)&outsocket);
	FtrGet(CREATORID, FTR_NET_PORT_ID, (unsigned long*)&gblDoomPort);
	FtrGet(CREATORID, FTR_SER_ROLE_ID, (unsigned long*)&n2PlayerRole);
	FtrGet(CREATORID, FTR_SER_PORT_ID, (unsigned long*)&nSerPortId);
	FtrGet(CREATORID, FTR_SER_OPEN_ID, (unsigned long*)&bSerPortOpened);
	FtrGet(CREATORID, FTR_DEBUGFILE_ID, (unsigned long*)&bDebugFile);
	FtrGet(CREATORID, FTR_VIDEO_RESX_ID, (unsigned long*)&SCREENWIDTH);
	FtrGet(CREATORID, FTR_VIDEO_RESY_ID, (unsigned long*)&SCREENHEIGHT);
	FtrGet(CREATORID, FTR_VIDEO_ROT_ID, (unsigned long*)&g_scr_rotated);
	FtrGet(CREATORID, FTR_MUSIC_MODE_ID, (unsigned long*)&g_music_mode);
	FtrGet(CREATORID, FTR_RUMBLE_ID, (unsigned long*)&g_rumble);

	FtrGet(CREATORID, FTR_WAD_FILENAME_ID, (unsigned long*)&ftrptr);
    strcpy(wad_filename,ftrptr/*+1*/);
    FtrPtrFree(CREATORID, FTR_WAD_FILENAME_ID);

    FtrGet(CREATORID, FTR_PWAD_FILENAME_ID ,(unsigned long*)&ftrptr);
    strcpy(pwad_filename,ftrptr/*+1*/);
	FtrPtrFree(CREATORID, FTR_PWAD_FILENAME_ID);

    FtrGet(CREATORID, FTR_OPT_INPUTCONF_ID ,(unsigned long*)&ftrptr);
	for (i=0; i<INPUT_CONFIG_COUNT; i++)
		g_confinput[i] = ByteSwap32(((UInt32*)ftrptr)[i]);
    
    if (bSerPortOpened || bNetLibOpened)
    {
    	unsigned long value;
		FtrGet(CREATORID, FTR_NOMONSTER_ID, &value);
		nomonsters = (boolean) value;
		FtrGet(CREATORID, FTR_RESPAWNMONSTER_ID, &value);
		respawnparm = (boolean) value;
		FtrGet(CREATORID, FTR_DEATHMODE_ID, &value);
		deathmatch = (boolean) value;
		FtrGet(CREATORID, FTR_STARTSKILL_ID, &value);
		gblStartSkill = (skill_t) value;
    }

	FtrGet(CREATORID, FTR_EPISODE_ID, (unsigned long*)&gblStartEpisode);
	FtrGet(CREATORID, FTR_MAP_ID, (unsigned long*)&gblStartMap);
    
	myargc = 3;//3;//argc; 	
	myargv = (char**)ydk_malloc(sizeof(char*)*5);
	myargv[0]="zdoom.prc";
	myargv[1]="-iwad";
	myargv[2]=wad_filename;
	if (pwad_filename[0])
	{
		myargc = 5;
		myargv[3]="-file";
  		myargv[4]=pwad_filename;
	}
										
	YDK_HANDLE_EVENT_NOFUNC()
	ClearScreen();
	
	D_DoomMain (); 
    ydk_free(myargv);

	for (i=0; i<FEATURE_ARRAY_COUNT; i++)
	{
		FtrPtrFree(CREATORID, FTR_NUM_LUMPBASE + i);
	}
   
	return 0;
}




/************************************/

void ClearScreen(void)
{
	UInt8 *vr;
	vr=(UInt8*)(g_pnobridge -> vram);
	for (int y=0;y<g_pnobridge -> display_height;y++)
	{
		memset(vr,0,g_pnobridge -> display_width*2);
		vr+=(g_pnobridge -> display_pitch)*2;
	}
}

void GpError ( char *s, ... ){
//	menu_info(s);
}

/*
 * The following functions provide hooks for stdin/stdout/stderr.
 * Applications may override them to do whatever they want. The
 * default implementation redirects console IO through ARM semihosting
 * interface.
 */
 
/*typedef unsigned long	__file_handle;
typedef void * __ref_con;
enum __io_results 
{
     __no_io_error,
     __io_error,
     __io_EOF         							
};

int
__close_console(__file_handle file)
{
    return __no_io_error;
}

int
__read_console(__file_handle file, unsigned char * buff, size_t * count, __ref_con ref_con)
{
    return __io_EOF;
}

int
__write_console(__file_handle file, unsigned char * buff, size_t * count, __ref_con ref_con)
{
    return __no_io_error;
}
*/
