// Emacs style mode select   -*- C++ -*- 
//-----------------------------------------------------------------------------
//
// $Id:$
//
// Copyright (C) 1993-1996 by id Software, Inc.
//
// This source is available for distribution and/or modification
// only under the terms of the DOOM Source Code License as
// published by id Software. All rights reserved.
//
// The source is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// FITNESS FOR A PARTICULAR PURPOSE. See the DOOM Source Code License
// for more details.
//
// $Log:$
//
// DESCRIPTION:
//
//-----------------------------------------------------------------------------

static const char
rcsid[] = "$Id: m_bbox.c,v 1.1 1997/02/03 22:45:10 b1 Exp $";

/*#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/ioctl.h>*/

#include "doomdef.h"

#include "i_system.h"
#include "d_event.h"
#include "d_net.h"
#include "m_argv.h"

#include "doomstat.h"

#ifdef __GNUG__
#pragma implementation "i_net.h"
#endif
#include "i_net.h"


UInt32 n2PlayerRole = 0;
UInt32 nSerPortId = 0;
UInt32 bSerPortOpened = 0;

UInt32 bNetLibOpened = 0;
UInt32 gblIPAddress = 0;
UInt32 netLibRefNum = 0;
UInt32 insocket = 0;
UInt32 outsocket = 0;
UInt32 gblDoomPort = 0;

typedef struct
{
	long  start;// 0xdeadbeef
	long  size; // size of data
	doomdata_t sw; // data to be send
} packet_t;


// For some odd reason...
#define ntohl(x) \
        ((unsigned long int)((((unsigned long int)(x) & 0x000000ffU) << 24) | \
                             (((unsigned long int)(x) & 0x0000ff00U) <<  8) | \
                             (((unsigned long int)(x) & 0x00ff0000U) >>  8) | \
                             (((unsigned long int)(x) & 0xff000000U) >> 24)))

#define ntohs(x) \
        ((unsigned short int)((((unsigned short int)(x) & 0x00ff) << 8) | \
                              (((unsigned short int)(x) & 0xff00) >> 8))) \
	  
#define htonl(x) ntohl(x)
#define htons(x) ntohs(x)

void	NetSend (void);
boolean NetListen (void);


//
// NETWORKING
//

//#define IPPORT_USERRESERVED = 5000
//int	DOOMPORT = IPPORT_USERRESERVED + 0x1d;

//int			sendsocket;
//int			insocket;

NetSocketAddrINType sendaddress[MAXNETNODES];

void	(*netget) (void);
void	(*netsend) (void);


//
// UDPsocket
//
int UDPsocket (void)
{
    int	s;
	
    // allocate a socket
/*    s = socket (PF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if (s<0)
	I_Error ("can't create socket: %s",strerror(errno));
		
    return s;*/
    return -1;
}

//
// BindToLocalPort
//
void
BindToLocalPort
( int	s,
  int	port )
{
/*    int			v;
    struct sockaddr_in	address;
	
    memset (&address, 0, sizeof(address));
    address.sin_family = AF_INET;
    address.sin_addr.s_addr = INADDR_ANY;
    address.sin_port = port;
			
    v = bind (s, (void *)&address, sizeof(address));
    if (v == -1)
	I_Error ("BindToPort: bind: %s", strerror(errno));*/
}


//
// PacketSend
//
void PacketSend (void)
{
    int		c;
//    doomdata_t	sw;
    Err err;
    packet_t myPacket = {0};
	
	myPacket.start = 0xdeadbeef;
	myPacket.size = doomcom->datalength;

    // byte swap
    myPacket.sw.checksum = htonl(netbuffer->checksum);
    myPacket.sw.player = netbuffer->player;
    myPacket.sw.retransmitfrom = netbuffer->retransmitfrom;
    myPacket.sw.starttic = netbuffer->starttic;
    myPacket.sw.numtics = netbuffer->numtics;
    for (c=0 ; c<netbuffer->numtics ; c++)
    {
	myPacket.sw.cmds[c].forwardmove = netbuffer->cmds[c].forwardmove;
	myPacket.sw.cmds[c].sidemove = netbuffer->cmds[c].sidemove;
	myPacket.sw.cmds[c].angleturn = htons(netbuffer->cmds[c].angleturn);
	myPacket.sw.cmds[c].consistancy = htons(netbuffer->cmds[c].consistancy);
	myPacket.sw.cmds[c].chatchar = netbuffer->cmds[c].chatchar;
	myPacket.sw.cmds[c].buttons = netbuffer->cmds[c].buttons;
    }
    if (debugfile)
    {
    int i;
	for (i=0 ; i<doomcom->datalength ; i++)
	    fprintf (debugfile,"%i ",((byte *)&myPacket.sw)[i]);
	fprintf (debugfile,"\n");
	}
	
//    Sys_PrintF ("sending %i (%ld bytes)", gametic, doomcom->datalength + 8);
//    menu_info("send");
	if (bSerPortOpened)
    {
		c = stub_SrmSend(nSerPortId, &myPacket, doomcom->datalength + 8, &err);
	}
	else if (bNetLibOpened)
	{
		c = stub_NetLibSend(netLibRefNum, outsocket, &myPacket.sw, doomcom->datalength, 0, &sendaddress[doomcom->remotenode], sizeof(sendaddress[doomcom->remotenode]), 0, &err);
		if (c == -1 )
			Sys_PrintF ("SendPacket error: 0x%x", err);
	}
//    Sys_PrintF ("send %i (%ld bytes) 0x%x", gametic, c, err);
/*
    c = sendto (sendsocket , &sw, doomcom->datalength
		,0,(void *)&sendaddress[doomcom->remotenode]
		,sizeof(sendaddress[doomcom->remotenode]));
*/
    //	if (c == -1)
    //		I_Error ("SendPacket error: %s",strerror(errno));
}


//
// PacketGet
//
void PacketGet (void)
{
    int			i;
    int			c;
//    struct sockaddr_in	fromaddress;
//    int			fromlen;
    doomdata_t		*sw;
    UInt32 id = 0, check = 0;
    long size = 0;
    char buffer[sizeof(doomdata_t)], *ptr;
    Err err;
/*
    fromlen = sizeof(fromaddress);
    c = recvfrom (insocket, &sw, sizeof(sw), 0
		  , (struct sockaddr *)&fromaddress, &fromlen );
    if (c == -1 )
    {
	if (errno != EWOULDBLOCK)
	    I_Error ("GetPacket: %s",strerror(errno));
	doomcom->remotenode = -1;		// no packet
	return;
    }

    {
	static int first=1;
	if (first)
	    Sys_PrintF("len=%d:p=[0x%x 0x%x] \n", c, *(int*)&sw, *((int*)&sw+1));
	first = 0;
    }

    // find remote node number
    for (i=0 ; i<doomcom->numnodes ; i++)
	if ( fromaddress.sin_addr.s_addr == sendaddress[i].sin_addr.s_addr )
	    break;

    if (i == doomcom->numnodes)
    {
	// packet is not from one of the players (new game broadcast)
	doomcom->remotenode = -1;		// no packet
	return;
    }
*/
	doomcom->remotenode = -1;
	if (bSerPortOpened)
    {
		err = stub_SrmReceiveCheck(nSerPortId, &check);
//	Sys_PrintF ("check %ld err: 0x%x", check, err);
		if (check < 4)
			return;

		if (stub_SrmReceive(nSerPortId, &id, 4, 0, &err) != 4)
			return;
		if (id != 0xdeadbeef)
			return;
//    Sys_PrintF ("header received");

		err = stub_SrmReceiveCheck(nSerPortId, &check);
//	Sys_PrintF ("check %ld err: 0x%x", check, err);
		if (check < 4)
			return;

		if (stub_SrmReceive(nSerPortId, &size, 4, 0, &err) != 4)
			return;
		c = size;
//    Sys_PrintF ("receiving %ld bytes", c);

		ptr = buffer;
		while (size > 0)
		{
			long read = stub_SrmReceive(nSerPortId, ptr, size, 0, &err);
			if (err != errNone)
				return;
			ptr += read;
			size -= read;
		}
	}
	else if (bNetLibOpened)
	{
		NetSocketAddrINType fromAddr = {0};
		UInt16 fromLength = sizeof(fromAddr);
		c = stub_NetLibReceive(netLibRefNum, insocket, buffer, sizeof(buffer), 0, (NetSocketAddrType *) &fromAddr, &fromLength, 0, &err);
		if (c <= 0 )
			return;
	}

	sw = (doomdata_t *) buffer;
    {
	static int first=1;
	if (first)
	    Sys_PrintF("len=%d:p=[0x%x 0x%x] \n", c, *(int*)&sw, *((int*)&sw+1));
	first = 0;
    }

	i = 1;

    doomcom->remotenode = i;			// good packet from a game player
    doomcom->datalength = c;
	
    // byte swap
    netbuffer->checksum = ntohl(sw->checksum);
    netbuffer->player = sw->player;
    netbuffer->retransmitfrom = sw->retransmitfrom;
    netbuffer->starttic = sw->starttic;
    netbuffer->numtics = sw->numtics;

    for (c=0 ; c<netbuffer->numtics ; c++)
    {
	netbuffer->cmds[c].forwardmove = sw->cmds[c].forwardmove;
	netbuffer->cmds[c].sidemove = sw->cmds[c].sidemove;
	netbuffer->cmds[c].angleturn = ntohs(sw->cmds[c].angleturn);
	netbuffer->cmds[c].consistancy = ntohs(sw->cmds[c].consistancy);
	netbuffer->cmds[c].chatchar = sw->cmds[c].chatchar;
	netbuffer->cmds[c].buttons = sw->cmds[c].buttons;
    }
    if (debugfile)
    {
    int i;
	for (i=0 ; i<doomcom->datalength ; i++)
	    fprintf (debugfile,"%i ",((byte *)sw)[i]);
	fprintf (debugfile,"\n");
	}
}



int GetLocalAddress (void)
{
/*    char		hostname[1024];
    struct hostent*	hostentry;	// host information entry
    int			v;

    // get local address
    v = gethostname (hostname, sizeof(hostname));
    if (v == -1)
	I_Error ("GetLocalAddress : gethostname: errno %d",errno);
	
    hostentry = gethostbyname (hostname);
    if (!hostentry)
	I_Error ("GetLocalAddress : gethostbyname: couldn't get local host");
		
    return *(int *)hostentry->h_addr_list[0];*/
    return 0;
}


//
// I_InitNetwork
//
void I_InitNetwork (void)
{
    boolean		trueval = true;
    int			i;
    int			p;
//    struct hostent*	hostentry;	// host information entry
	
    doomcom = ydk_malloc (sizeof (*doomcom) );
    memset (doomcom, 0, sizeof(*doomcom) );
    
    // set up for network
    i = M_CheckParm ("-dup");
    if (i && i< myargc-1)
    {
	doomcom->ticdup = myargv[i+1][0]-'0';
	if (doomcom->ticdup < 1)
	    doomcom->ticdup = 1;
	if (doomcom->ticdup > 9)
	    doomcom->ticdup = 9;
    }
    else
	doomcom-> ticdup = 1;
	
    if (M_CheckParm ("-extratic"))
	doomcom-> extratics = 1;
    else
	doomcom-> extratics = 0;
	
    p = M_CheckParm ("-port");
    if (p && p<myargc-1)
    {
	gblDoomPort = atoi (myargv[p+1]);
	Sys_PrintF ("using alternate port %i", gblDoomPort);
    }
    
    // parse network game options,
    //  -net <consoleplayer> <host> <host> ...
//    i = M_CheckParm ("-net");
//    if (!i)
    if (!bSerPortOpened && !bNetLibOpened)
    {
	// single player game
	netgame = false;
	doomcom->id = DOOMCOM_ID;
	doomcom->numplayers = doomcom->numnodes = 1;
	doomcom->deathmatch = false;
	doomcom->consoleplayer = 0;
	return;
    }

    netsend = PacketSend;
    netget = PacketGet;
    netgame = true;
    doomcom->consoleplayer = n2PlayerRole;
    doomcom->numnodes = 2;	// this node for sure

	if (bNetLibOpened)
	{
		sendaddress[1].family = netSocketAddrINET;
		sendaddress[1].port = htons(gblDoomPort);
		sendaddress[1].addr = htonl(gblIPAddress);
	}
/*
    // parse player number and host list
    doomcom->consoleplayer = myargv[i+1][0]-'1';

    doomcom->numnodes = 1;	// this node for sure
	
    i++;
    while (++i < myargc && myargv[i][0] != '-')
    {
	sendaddress[doomcom->numnodes].sin_family = AF_INET;
	sendaddress[doomcom->numnodes].sin_port = htons(DOOMPORT);
	if (myargv[i][0] == '.')
	{
	    sendaddress[doomcom->numnodes].sin_addr.s_addr 
		= inet_addr (myargv[i]+1);
	}
	else
	{
	    hostentry = gethostbyname (myargv[i]);
	    if (!hostentry)
		I_Error ("gethostbyname: couldn't find %s", myargv[i]);
	    sendaddress[doomcom->numnodes].sin_addr.s_addr 
		= *(int *)hostentry->h_addr_list[0];
	}
	doomcom->numnodes++;
    }*/
	
    doomcom->id = DOOMCOM_ID;
    doomcom->numplayers = doomcom->numnodes;

    // build message to receive
/*    insocket = UDPsocket ();
    BindToLocalPort (insocket,htons(DOOMPORT));
    ioctl (insocket, FIONBIO, &trueval);

    sendsocket = UDPsocket ();*/
}


void I_NetCmd (void)
{
    if (!bSerPortOpened && !bNetLibOpened)
    	return;

    if (doomcom->command == CMD_SEND)
    {
	netsend ();
    }
    else if (doomcom->command == CMD_GET)
    {
	netget ();
    }
    else
	I_Error ("Bad net cmd: %i\n",doomcom->command);
}

