// Emacs style mode select   -*- C++ -*- 
//-----------------------------------------------------------------------------
//
// $Id:$
//
// Copyright (C) 1993-1996 by id Software, Inc.
//
// This source is available for distribution and/or modification
// only under the terms of the DOOM Source Code License as
// published by id Software. All rights reserved.
//
// The source is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// FITNESS FOR A PARTICULAR PURPOSE. See the DOOM Source Code License
// for more details.
//
// $Log:$
//
// DESCRIPTION:
//
//-----------------------------------------------------------------------------

static const char
rcsid[] = "$Id: m_bbox.c,v 1.1 1997/02/03 22:45:10 b1 Exp $";


/*#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <stdarg.h>
#include <sys/time.h>
#include <unistd.h>*/

#include "doomdef.h"
#include "m_misc.h"
#include "i_video.h"
#include "i_sound.h"

#include "d_net.h"
#include "g_game.h"

#ifdef __GNUG__
#pragma implementation "i_system.h"
#endif
#include "i_system.h"


extern char exit_doom;

int	mb_used = 8;//6;


void
I_Tactile
( int	on,
  int	off,
  int	total )
{
  // UNUSED.
  on = off = total = 0;
}

ticcmd_t	emptycmd;
ticcmd_t*	I_BaseTiccmd(void)
{
    return &emptycmd;
}


int  I_GetHeapSize (void)
{
    return mb_used * 256L * 1024L;
}

byte* I_ZoneBase (int*	size)
{
	byte *res;
	int bytes, max;

	MemHeapFreeBytes(0, &bytes, &max );

	mb_used = max / 1024L / 256L;
	if (mb_used < 12)
		mb_used = 12;
  	for (;;)
  	{
  		// leave at least 256 kB free
    	res = (byte *) ydk_malloc ((mb_used * 256L + 256L) * 1024L);
    	if (res) break;
    	if ( mb_used > 16)
    		mb_used -= 4;
    	else if ( mb_used > 12)
    		mb_used -= 2;
    	else
    		mb_used--;
    }
    free(res);

    *size = mb_used * 256L * 1024L;
   	res = (byte *) ydk_malloc (*size);

    Sys_PrintF("Allocated %ldKB (%ld)", (*size)>>10, mb_used);
    if (mb_used < 8)
    	I_Error("Warning low mem");
    
   	
    return res;
}



//
// I_GetTime
// returns time in 1/70th second tics
//
int  I_GetTime (void)
{
/*    struct timeval	tp;
    struct timezone	tzp;
    int			newtics;
    static int		basetime=0;
  
    gettimeofday(&tp, &tzp);
    if (!basetime)
	basetime = tp.tv_sec;
    newtics = (tp.tv_sec-basetime)*TICRATE + tp.tv_usec*TICRATE/1000000;
    return newtics;*/
    static int		basetime=0;
    int newtics=GetTickCount();
    if (!basetime) basetime=newtics;
    
    return (newtics-basetime)*TICRATE/1000;
}



//
// I_Init
//
void I_Init (void)
{
    I_InitSound();
    //  I_InitGraphics();
}

//
// I_Quit
//
void I_Quit (void)
{
/*    D_QuitNetGame ();
    I_ShutdownSound();
    I_ShutdownMusic();
    M_SaveDefaults ();
    I_ShutdownGraphics();*/
    

	exit_doom=1;
//    exit(0);
}

void I_WaitVBL(int count)
{
/*#ifdef SGI
    sginap(1);                                           
#else
#ifdef SUN
    sleep(0);
#else
    usleep (count * (1000000/70) );                                
#endif
#endif*/
}

void I_BeginRead(void)
{
}

void I_EndRead(void)
{
}

byte*	I_AllocLow(int length)
{
    byte*	mem;
        
    mem = (byte *)ydk_malloc (length);
    memset (mem,0,length);
    return mem;
}


//
// I_Error
//
extern boolean demorecording;

void I_Error (char *error, ...)
{
    va_list	argptr;
    char text[1024];
    
    // Message first.
    va_start (argptr,error);

    vsprintf (text,error,argptr);

    va_end (argptr);

    //fflush( stderr );
    menu_info(text);
//	menu_message(text);


/*    // Shutdown. Here might be other errors.
    if (demorecording)
	G_CheckDemoStatus();

    D_QuitNetGame ();
    I_ShutdownGraphics();
    
    exit(-1);*/
}
