// Emacs style mode select   -*- C++ -*- 
//-----------------------------------------------------------------------------
//
// $Id:$
//
// Copyright (C) 1993-1996 by id Software, Inc.
//
// This source is available for distribution and/or modification
// only under the terms of the DOOM Source Code License as
// published by id Software. All rights reserved.
//
// The source is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// FITNESS FOR A PARTICULAR PURPOSE. See the DOOM Source Code License
// for more details.
//
// $Log:$
//
// DESCRIPTION:
//	DOOM graphics stuff for X11, UNIX.
//
//-----------------------------------------------------------------------------

static const char
rcsid[] = "$Id: i_x.c,v 1.6 1997/02/03 22:45:10 b1 Exp $";



#include "doomstat.h"
#include "i_system.h"
#include "v_video.h"
#include "m_argv.h"
#include "d_main.h"

#include "doomdef.h"

#include "PNOmain.h"

extern UInt32 device_type;

//#include "filters.h"

//
//  Translates the key currently in X_event
//


static UInt16 curpal[256];

extern char gpstr[256];

int g_scr_rotated=0;

int boolKeyboard=0;
int nShowScreenButtons=0;

void I_ShutdownGraphics(void)
{
}



//
// I_StartFrame
//
void I_StartFrame (void)
{
    // er?

}

#define KEY_UP				0x00000001
#define KEY_DOWN			0x00000002
#define KEY_LEFT			0x00000004
#define KEY_RIGHT			0x00000008
#define KEY_RUN				0x00000010
#define KEY_STRAFE			0x00000020
#define KEY_STRAFE_L		0x00000040
#define KEY_STRAFE_R		0x00000080
#define KEY_FIRE			0x00000100
#define KEY_USE				0x00000200
#define KEY_CHANGEWEAPON	0x00000400
#define KEY_MAP 			0x00000800
#define KEY_MENU			0x00001000
#define KEY_GAMMA			0x00002000
#define KEY_PLUS			0x00004000
#define KEY_MOINS			0x00008000


unsigned int g_translateBtn[INPUT_CONFIG_COUNT]=
{KEY_UP,KEY_DOWN,KEY_LEFT,KEY_RIGHT,
KEY_RUN,KEY_STRAFE,KEY_STRAFE_L,KEY_STRAFE_R,
KEY_FIRE,KEY_USE,KEY_CHANGEWEAPON,KEY_MAP,KEY_MENU,
KEY_GAMMA,KEY_PLUS,KEY_MOINS,0,0,0,0};

extern int g_confinput[INPUT_CONFIG_COUNT];

char consoleCmd[32];

#define KEY_WIDTH 25
#define KEY_HEIGHT 25

void I_GetEvent(void)
{
	static int pollcpt=0;
	event_t event;
	
	UInt32 keyval;
	static UInt32 old_key=0;
	UInt32 key;
	static char old_kbkey=0;
	char kbkey;
	static UInt32 old_treokey=0;
	UInt32 treokey;
	static char old_treokbkey=0;
	char treokbkey;
	UInt32 penX, penY, penDown;
	int i;
	
	pollcpt++;
	if (pollcpt&1) return;
/*
	if (bSerPortOpened)
	{
		EventType myevent;
		SysEventGet(&myevent,0);
		if (myevent.eType != keyDownEvent)
			SysHandleEvent(&myevent);
	}
*/	
#define IsPress(a) (((keyval&a)==a)&&!((old_key&a)==a))
#define IsNotPress(a) (!((keyval&a)==a)&&((old_key&a)==a))
#define HandleKey(a,b) {\
	if (IsPress(a)){		\
		event.type = ev_keydown;\
		event.data1 = b;\
		D_PostEvent(&event);\
	}\
	if (IsNotPress(a)){\
		event.type = ev_keyup;\
		event.data1 = b;\
		D_PostEvent(&event);\
	}}	
	
	keyval=0;
	key = KeyCurrentState();		
	
	penDown=0;
	/*if (!(pollcpt&3))*/{
		EvtGetPen(&penX,&penY,&penDown);
		
	}
	//handle sys event
#ifndef ENABLE_ZGRAB	
	if (!(pollcpt&31)) {YDK_HANDLE_EVENT()}
#else
	YDK_HANDLE_EVENT()
#endif	
	//avoid autoff
	//every 1024 frame => 
	if (!(pollcpt&1023))
		EvtResetAutoOffTimer();
	
	if (penDown)
	{
		PointType pt;
		pt.x=penX;
		pt.y=penY;
		EvtEnqueuePenPoint(&pt);
	}

	penX*=_PEN_ADJUST_FACTORX_;
	penY*=_PEN_ADJUST_FACTORY_;
	if (penDown)
	{
		if (boolKeyboard)
		{
			int y = (penY - (SCREENHEIGHT/*display_height*/ - (5 * KEY_HEIGHT) - (KEY_HEIGHT / 2))) / KEY_HEIGHT;
			
			kbkey = 0;
			
			if (y == 0)
			{
				int x = penX / KEY_WIDTH;

				if (x == 0) kbkey = '1';
				else if (x == 1) kbkey = '2';
				else if (x == 2) kbkey = '3';
				else if (x == 3) kbkey = '4';
				else if (x == 4) kbkey = '5';
				else if (x == 5) kbkey = '6';
				else if (x == 6) kbkey = '7';
				else if (x == 7) kbkey = '8';
				else if (x == 8) kbkey = '9';
				else if (x == 9) kbkey = '0';
				else if (x == 10) kbkey = KEY_BACKSPACE;
			}
			else if (y == 1)
			{
				int x = (penX - (KEY_WIDTH / 2)) / KEY_WIDTH;

				if (x == 0) kbkey = 'Q';
				else if (x == 1) kbkey = 'W';
				else if (x == 2) kbkey = 'E';
				else if (x == 3) kbkey = 'R';
				else if (x == 4) kbkey = 'T';
				else if (x == 5) kbkey = 'Y';
				else if (x == 6) kbkey = 'U';
				else if (x == 7) kbkey = 'I';
				else if (x == 8) kbkey = 'O';
				else if (x == 9) kbkey = 'P';
			}
			else if (y == 2)
			{
				int x = (penX - KEY_WIDTH) / KEY_WIDTH;

				if (x == 0) kbkey = 'A';
				else if (x == 1) kbkey = 'S';
				else if (x == 2) kbkey = 'D';
				else if (x == 3) kbkey = 'F';
				else if (x == 4) kbkey = 'G';
				else if (x == 5) kbkey = 'H';
				else if (x == 6) kbkey = 'J';
				else if (x == 7) kbkey = 'K';
				else if (x == 8) kbkey = 'L';
			}
			else if (y == 3)
			{
				int x = (penX - KEY_WIDTH - (KEY_WIDTH / 2)) / KEY_WIDTH;

				if (x == 0) kbkey = 'Z';
				else if (x == 1) kbkey = 'X';
				else if (x == 2) kbkey = 'C';
				else if (x == 3) kbkey = 'V';
				else if (x == 4) kbkey = 'B';
				else if (x == 5) kbkey = 'N';
				else if (x == 6) kbkey = 'M';
				else if (x == 7) kbkey = '-';
				else if (x == 8) kbkey = '.';
			}
			else if (y == 4)
			{
				int x = (penX - (2 * KEY_WIDTH)) / KEY_WIDTH;

				if ((x >= 0) && (x <= 5)) kbkey = ' ';
				else if ((x == 6) || (x == 7)) boolKeyboard = 0;
			}
			if (old_kbkey != kbkey)
			{
				if (old_kbkey != 0)
				{
					event.type = ev_keyup;
					event.data1 = old_kbkey;
					D_PostEvent(&event);
				}
				if (kbkey != 0)
				{
					event.type = ev_keydown;
					event.data1 = kbkey;
					D_PostEvent(&event);
				}
			}
			old_kbkey = kbkey;
		}
		else
		{
			int width, height;
		
			if (g_scr_rotated)
			{
				width = display_width;
				height = display_height;
			}
			else
			{
				width = SCREENWIDTH;
				height = SCREENHEIGHT;
			}

		    nShowScreenButtons = 10;
		 	if ((penY>0)&&(penY<60)&&(penX>width-80)&&(penX<width)) key=BTN_TR;
	 		else if ((penY>(height>>1)-30)&&(penY<(height>>1)+30)&&(penX>width-80)&&(penX<width)) key=BTN_MR;
			else if ((penY>height-60)&&(penY<height)&&(penX>width-80)&&(penX<width)) key=BTN_BR;
			else if ((penY>0)&&(penY<60)&&(penX>0)&&(penX<80)) key=BTN_TL;
			else if ((penY>(height>>1)-30)&&(penY<(height>>1)+30)&&(penX>0)&&(penX<80)) key=BTN_ML;
			else if ((penY>height-60)&&(penY<height)&&(penX>0)&&(penX<80)) key=BTN_BL;
			else if ((penY>0)&&(penY<60)&&(penX>(width>>1)-40)&&(penX<(width>>1)+40)) key=BTN_TM;
	 		else if ((penY>height-60)&&(penY<height)&&(penX>(width>>1)-40)&&(penX<(width>>1)+40)) key=BTN_BM;
		 	else if ((penY>(height>>1)-30)&&(penY<(height>>1))&&(penX>(width>>1)-40)&&(penX<(width>>1)+40))
		 	{
		 		char *c;
		 		int result;
		 		stub_consoleCmd(consoleCmd);
//		 		YDK_HANDLE_EVENT_NOFUNC()
		 		c = consoleCmd;
	 			if (strcmp(c, "gamma")==0)
		 		{
	 				event.type = ev_keydown;
					event.data1 = KEY_F11;
					D_PostEvent(&event);
					event.type = ev_keyup;
					event.data1 = KEY_F11;
					D_PostEvent(&event);
	 			}
	 			else if ((strcmp(c,"quit")==0) || (strcmp(c,"/q")==0))
		 		{
	 				event.type = ev_keydown;
					event.data1 = KEY_F10;
					D_PostEvent(&event);
					event.type = ev_keyup;
					event.data1 = KEY_F10;
					D_PostEvent(&event);
					event.type = ev_keydown;
					event.data1 = 'y';
					D_PostEvent(&event);
					event.type = ev_keyup;
					event.data1 = 'y';
					D_PostEvent(&event);
	 			}
	 			else
	 			{
					while (*c)
					{
						event.type = ev_keydown;
						event.data1 = *c;
						D_PostEvent(&event);
						event.type = ev_keyup;
						event.data1 = *c++;
						D_PostEvent(&event);
					}
				}
	 		}
			else if ((penY>(height>>1))&&(penY<(height>>1)+30)&&(penX>(width>>1)-40)&&(penX<(width>>1)+40))
			{
				boolKeyboard = 1;
			}
	 	}
	}
	else if (old_kbkey != 0)
	{
		event.type = ev_keyup;
		event.data1 = old_kbkey;
		D_PostEvent(&event);
		old_kbkey = 0;
	}
	
	//if ((key==BTN_TM)||(key==BTN_BM)||(key==BTN_TL)||(key==BTN_TR)||(key==BTN_ML)||(key==BTN_MR)||(key==BTN_BL)||(key==BTN_BR)){
	if (penDown)
	{
		if (boolKeyboard == 0)
		{
			for (int i=0; i<INPUT_CONFIG_COUNT; i++)
				if (g_confinput[i] != 0)
					if (key == g_confinput[i]) {keyval = g_translateBtn[i]; break;}
		}
	}
	else
	{
		for (i=0; i<INPUT_CONFIG_COUNT; i++)
			if (g_confinput[i] != 0)
				if ((key & g_confinput[i]) == g_confinput[i]) keyval |= g_translateBtn[i];	
	}

	if (device_type & BF_TREO)
	{
		treokey = 0;
		treokbkey = 0;

		if (treokey = stubtreokeys())
		{
			if (treokey & 0x80000000)
			{
				if (boolKeyboard)
				{
					// post the key, as we use it as real key
					treokbkey = treokey & 0xff;
					if ((old_treokbkey != treokbkey) && (treokbkey != 0))
					{
						event.type = ev_keydown;
						event.data1 = treokbkey;
						D_PostEvent(&event);
					}
				}
				else
				{
					if (((treokey & 0xff) >= '0') && ((treokey & 0xff) <= '9') && (treokey != old_treokey))
					{
						// handle weapons
						event.type = ev_keydown;
						event.data1 = treokey & 0xff;
						D_PostEvent(&event);
					}
					else
					{
						// just map the key, FIXME: only one key at the moment
						for (int i=0; i<INPUT_CONFIG_COUNT; i++)
							if (g_confinput[i] != 0)
								if (treokey == g_confinput[i]) {keyval |= g_translateBtn[i]; break;}
					}
				}
			}
		}

		if ((old_treokbkey != 0) && (old_treokbkey != treokbkey))
		{
			event.type = ev_keyup;
			event.data1 = old_treokbkey;
			D_PostEvent(&event);
		}

		if (((old_treokey & 0xff) >= '0') && ((old_treokey & 0xff) <= '9') && (treokey != old_treokey))
		{
			event.type = ev_keyup;
			event.data1 = old_treokey & 0xff;
			D_PostEvent(&event);
		}

		old_treokbkey = treokbkey;
		old_treokey = treokey;
	}

	HandleKey(KEY_MAP, KEY_TAB)
	HandleKey(KEY_CHANGEWEAPON, '/')
	HandleKey(KEY_FIRE, KEY_RCTRL)
	HandleKey(KEY_RUN, KEY_RSHIFT)
	HandleKey(KEY_USE, ' ')
	HandleKey(KEY_STRAFE, KEY_RALT)
	HandleKey(KEY_STRAFE_L, ',')
	HandleKey(KEY_STRAFE_R, '.')
	HandleKey(KEY_MENU, KEY_ESCAPE)
	HandleKey(KEY_UP, KEY_UPARROW)
	HandleKey(KEY_DOWN, KEY_DOWNARROW)
	HandleKey(KEY_LEFT, KEY_LEFTARROW)
	HandleKey(KEY_RIGHT, KEY_RIGHTARROW)
	HandleKey(KEY_GAMMA, KEY_F11)
	HandleKey(KEY_PLUS, KEY_MINUS)
	HandleKey(KEY_MOINS, KEY_EQUALS)

#undef HandleKey
#undef IsPress
#undef IsNotPress



	old_key=keyval;
}

//
// I_StartTic
//
void I_StartTic (void)
{
 	I_GetEvent();    
}


//
// I_UpdateNoBlit
//
void I_UpdateNoBlit (void)
{
    // what is this?
}

//
// I_FinishUpdate
//

void zq_asmfastrender480(UInt16 *dst,UInt8 *src,UInt16 *pal,UInt32 pitch,UInt32 h);
void zq_asmfastrender480r(UInt16 *dst,UInt8 *src,UInt16 *pal,UInt32 pitch,UInt32 h);
void zq_asmfastrender320(UInt16 *dst,UInt8 *src,UInt16 *pal,UInt32 pitch,UInt32 h);

#define myWinPaintRectangleFrame(r, d) \
           WinDrawLine(r.topLeft.x + d, r.topLeft.y, r.topLeft.x + r.extent.x - 1 - d, r.topLeft.y); \
           WinDrawLine(r.topLeft.x + r.extent.x - 1 - d, r.topLeft.y, r.topLeft.x + r.extent.x - 1, r.topLeft.y + d); \
           WinDrawLine(r.topLeft.x + r.extent.x - 1, r.topLeft.y + d, r.topLeft.x + r.extent.x - 1, r.topLeft.y + r.extent.y - 1 - d); \
           WinDrawLine(r.topLeft.x + r.extent.x - 1, r.topLeft.y + r.extent.y - 1 - d, r.topLeft.x + r.extent.x - 1 - d, r.topLeft.y + r.extent.y - 1); \
           WinDrawLine(r.topLeft.x + d, r.topLeft.y + r.extent.y - 1, r.topLeft.x + r.extent.x - 1 - d, r.topLeft.y + r.extent.y - 1); \
           WinDrawLine(r.topLeft.x + d, r.topLeft.y + r.extent.y - 1, r.topLeft.x, r.topLeft.y + r.extent.y - 1 - d); \
           WinDrawLine(r.topLeft.x, r.topLeft.y + d, r.topLeft.x, r.topLeft.y + r.extent.y - 1 - d); \
           WinDrawLine(r.topLeft.x, r.topLeft.y + d, r.topLeft.x + d, r.topLeft.y);

void I_FinishUpdate (void)
{
	int xx,yy;
	UInt16 *dest;
	UInt8 *src;
	int scale = 1;
	
	dest=(UInt16*)(g_pnobridge->vram);
	src=(UInt8*)(screens[0]);

	if (g_pnobridge->display_width == 160)
	{
		// SCREENWIDTH/SCREENHEIGHT is always 320 based?
		// so we need to half in both directions
		scale = 2;
		for (yy=SCREENHEIGHT; yy; yy-=2)
		{
			for (xx=SCREENWIDTH; xx; xx-=2)
			{
				// FIXME: it's only an half scaler, where are the lines? :-)
				UInt16 pxl1 = curpal[*src++];
				UInt16 red = (pxl1 >> 8) & 0xf8;
				UInt16 green = (pxl1 >> 3) & 0xfc;
				UInt16 blue = (pxl1 << 3) & 0xf8;

				UInt16 pxl2 = curpal[*src++];
				red += (pxl2 >> 8) & 0xf8;
				green += (pxl2 >> 3) & 0xfc;
				blue += (pxl2 << 3) & 0xf8;

				// divide by 2
				UInt16 value = ((red << 7) & 0xf800) | ((green << 2) & 0x07e0) | ((blue >> 4) & 0x001f);
				*dest++ = value;
			}
			src += SCREENWIDTH;
		}
	}
	else
	{
		if (SCREENWIDTH==480)
		{
			if (g_scr_rotated)
			{
				zq_asmfastrender480r(dest,src,curpal,(g_pnobridge->display_pitch)*2,SCREENHEIGHT);
			}
			else
			{
				zq_asmfastrender480(dest,src,curpal,(g_pnobridge->display_pitch)*2,SCREENHEIGHT);
			}
		}
		else if (SCREENWIDTH==320)
		{
			zq_asmfastrender320(dest,src,curpal,(g_pnobridge->display_pitch)*2,SCREENHEIGHT);
		}
		else
		{
			for (yy=SCREENHEIGHT;yy;yy--)
			{
				for (xx=SCREENWIDTH;xx;xx--)
				{
					*dest++=curpal[*src++];
				}
				dest+=(g_pnobridge->display_pitch)-SCREENWIDTH;
			}
		}
	}
	
	if (nShowScreenButtons > 0)
	{
		RGBColorType fg;	
		RectangleType rect;	
		char *p;
		int x, y;
		int width, height;
		
		if (g_scr_rotated)
		{
			width = display_width;
			height = display_height;
		}
		else
		{
			width = SCREENWIDTH;
			height = SCREENHEIGHT;
		}
	
		WinPushDrawState();
		WinSetCoordinateSystem(kCoordinatesNative);

		WinSetDrawMode(winOverlay);

	    fg.r = 220; fg.g = 180; fg.b = 40;
    	WinSetForeColorRGB(&fg, NULL);

		rect.topLeft.x = (width-80)/scale;
		rect.topLeft.y = 0/scale;
		rect.extent.x = 80/scale;
		rect.extent.y = 60/scale;
		myWinPaintRectangleFrame(rect, 5);

		rect.topLeft.x = (width-80)/scale;
		rect.topLeft.y = ((height>>1)-30)/scale;
		rect.extent.x = 80/scale;
		rect.extent.y = 60/scale;
		myWinPaintRectangleFrame(rect, 5);

		rect.topLeft.x = (width-80)/scale;
		rect.topLeft.y = (height-60)/scale;
		rect.extent.x = 80/scale;
		rect.extent.y = 60/scale;
		myWinPaintRectangleFrame(rect, 5);

		rect.topLeft.x = 0/scale;
		rect.topLeft.y = 0/scale;
		rect.extent.x = 80/scale;
		rect.extent.y = 60/scale;
		myWinPaintRectangleFrame(rect, 5);

		rect.topLeft.x = 0/scale;
		rect.topLeft.y = ((height>>1)-30)/scale;
		rect.extent.x = 80/scale;
		rect.extent.y = 60/scale;
		myWinPaintRectangleFrame(rect, 5);

		rect.topLeft.x = 0/scale;
		rect.topLeft.y = (height-60)/scale;
		rect.extent.x = 80/scale;
		rect.extent.y = 60/scale;
		myWinPaintRectangleFrame(rect, 5);

		rect.topLeft.x = ((width>>1)-40)/scale;
		rect.topLeft.y = 0/scale;
		rect.extent.x = 80/scale;
		rect.extent.y = 60/scale;
		myWinPaintRectangleFrame(rect, 5);

		rect.topLeft.x = ((width>>1)-40)/scale;
		rect.topLeft.y = ((height>>1)-30)/scale;
		rect.extent.x = 80/scale;
		rect.extent.y = 28/scale;
		myWinPaintRectangleFrame(rect, 5);

		rect.topLeft.x = ((width>>1)-40)/scale;
		rect.topLeft.y = (height>>1)/scale;
		rect.extent.x = 80/scale;
		rect.extent.y = 28/scale;
		myWinPaintRectangleFrame(rect, 5);

		rect.topLeft.x = ((width>>1)-40)/scale;
		rect.topLeft.y = (height-60)/scale;
		rect.extent.x = 80/scale;
		rect.extent.y = 60/scale;
		myWinPaintRectangleFrame(rect, 5);

		WinPopDrawState();

		nShowScreenButtons--;
	}

	if (boolKeyboard)
	{
		RGBColorType fg;	
		RectangleType rect;	
		char *p;
		int x, y;
	
		WinPushDrawState();
		WinSetCoordinateSystem(kCoordinatesNative);

		WinSetDrawMode(winOverlay);
//		WinSetDrawMode(winPaint);
		FntSetFont(stdFont);

	    fg.r = 110; fg.g = 90; fg.b = 20;
    	WinSetForeColorRGB(&fg, NULL);
	    fg.r = 220; fg.g = 180; fg.b = 40;
		WinSetTextColorRGB(&fg, NULL);
    	for (y = 0; y < 5; y++)
    	{
			rect.topLeft.y = ((SCREENHEIGHT/*display_height*/ - (5 * KEY_HEIGHT) - (KEY_HEIGHT / 2)) + (y * KEY_HEIGHT)) / scale;
			if (y == 0)
			{
				const char *chrs[11] = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "<"};
				for (x = 0; x < 11; x++)
				{
					rect.topLeft.x = (x * KEY_WIDTH)/scale;
					rect.extent.x = (KEY_WIDTH - 2)/scale;
					rect.extent.y = (KEY_HEIGHT - 2)/scale;
					myWinPaintRectangleFrame(rect, 5);
					WinPaintChars(chrs[x], 1, rect.topLeft.x + ((rect.extent.x - FntCharsWidth(chrs[x], 1)) / 2), rect.topLeft.y + (((KEY_HEIGHT- 2) - FntCharHeight()) / 2)/* - (FntCharHeight() / 2)*/);
				}
			}
			else if (y == 1)
			{
				const char *chrs[10] = {"Q", "W", "E", "R", "T", "Y", "U", "I", "O", "P"};
				for (x = 0; x < 10; x++)
				{
					rect.topLeft.x = ((KEY_WIDTH / 2) + (x * KEY_WIDTH))/scale;
					rect.extent.x = (KEY_WIDTH - 2)/scale;
					rect.extent.y = (KEY_HEIGHT - 2)/scale;
					myWinPaintRectangleFrame(rect, 5);
					WinPaintChars(chrs[x], 1, rect.topLeft.x + ((rect.extent.x - FntCharsWidth(chrs[x], 1)) / 2), rect.topLeft.y + (((KEY_HEIGHT- 2) - FntCharHeight()) / 2)/* - (FntCharHeight() / 2)*/);
				}
			}
			else if (y == 2)
			{
				const char *chrs[9] = {"A", "S", "D", "F", "G", "H", "J", "K", "L"};
				for (x = 0; x < 9; x++)
				{
					rect.topLeft.x = (KEY_WIDTH + (x * KEY_WIDTH))/scale;
					rect.extent.x = (KEY_WIDTH - 2)/scale;
					rect.extent.y = (KEY_HEIGHT - 2)/scale;
					myWinPaintRectangleFrame(rect, 5);
					WinPaintChars(chrs[x], 1, rect.topLeft.x + ((rect.extent.x - FntCharsWidth(chrs[x], 1)) / 2), rect.topLeft.y + (((KEY_HEIGHT- 2) - FntCharHeight()) / 2)/* - (FntCharHeight() / 2)*/);
				}
			}
			else if (y == 3)
			{
				const char *chrs[9] = {"Z", "X", "C", "V", "B", "N", "M", "-", "."};
				for (x = 0; x < 9; x++)
				{
					rect.topLeft.x = (KEY_WIDTH + (KEY_WIDTH / 2) + (x * KEY_WIDTH))/scale;
					rect.extent.x = (KEY_WIDTH - 2)/scale;
					rect.extent.y = (KEY_HEIGHT - 2)/scale;
					myWinPaintRectangleFrame(rect, 5);
					WinPaintChars(chrs[x], 1, rect.topLeft.x + ((rect.extent.x - FntCharsWidth(chrs[x], 1)) / 2), rect.topLeft.y + (((KEY_HEIGHT- 2) - FntCharHeight()) / 2)/* - (FntCharHeight() / 2)*/);
				}
			}
			else if (y == 4)
			{
				/* space */
				rect.topLeft.x = (2 * KEY_WIDTH)/scale;
				rect.extent.x = ((6 * KEY_WIDTH) - 2)/scale;
				rect.extent.y = (KEY_HEIGHT - 2)/scale;
				myWinPaintRectangleFrame(rect, 5);
				WinPaintChars("Space", 5, rect.topLeft.x + ((rect.extent.x - FntCharsWidth("Space", 5)) / 2), rect.topLeft.y + (((KEY_HEIGHT- 2) - FntCharHeight()) / 2)/* - (FntCharHeight() / 2)*/);

				/* close */
				rect.topLeft.x = ((2 * KEY_WIDTH) + (6 * KEY_WIDTH))/scale;
				rect.extent.x = ((2 * KEY_WIDTH) - 2)/scale;
				rect.extent.y = (KEY_HEIGHT - 2)/scale;
				myWinPaintRectangleFrame(rect, 5);
				WinPaintChars("", 1, rect.topLeft.x + ((rect.extent.x - FntCharsWidth("", 1)) / 2), rect.topLeft.y + (((KEY_HEIGHT- 2) - FntCharHeight()) / 2)/* - (FntCharHeight() / 2)*/);
			}
		}

		WinPopDrawState();
	}
}


//
// I_ReadScreen
//
void I_ReadScreen (byte* scr)
{
    memcpy (scr, screens[0], SCREENWIDTH*SCREENHEIGHT);
}


//
// Palette stuff.
//



//
// I_SetPalette
//
void I_SetPalette (byte* palette)
{
	UInt16 c;
	int i;
    for (i=0 ; i<256 ; i++)
	    {
		c =  (gammatable[usegamma][*palette++]>>3)<<11;
		c |= (gammatable[usegamma][*palette++]>>2)<<5;
		c |= (gammatable[usegamma][*palette++]>>3);
		curpal[i]=c;
	    }
}



void I_InitGraphics(void)
{
//	filters_init();
	screens[0] = (unsigned char *) ydk_malloc (SCREENWIDTH * SCREENHEIGHT);
	memset(screens[0],0,SCREENWIDTH * SCREENHEIGHT);
}

int dummy_align5;
byte tmp_screen[320*200];

void I_Extend320200ToScreen(UInt8 *vid){
	byte *pp,*q;
	int xt,yt,xx,yy,xincr,yincr,xofs,yofs;
	
	if ((SCREENWIDTH==320)||!vid) return;

	
	pp=tmp_screen;q=vid;
	for (yy=0;yy<200;yy++){
		memcpy(pp,q,320);
		pp+=320;
		q+=SCREENWIDTH;
	}
	
	q=vid;
	yofs=0;yincr=(200<<16)/SCREENHEIGHT;
	xincr=(320<<16)/SCREENWIDTH;
	for (yy=0;yy<SCREENHEIGHT;yy++){
		xofs=0;
		yt=(yofs>>16); if (yt>199) yt=199;
		pp=&tmp_screen[yt*320];
		for (xx=0;xx<SCREENWIDTH;xx++){
			xt=(xofs>>16); if (xt>319) xt=319;
			q[xx]=pp[xt];			
			xofs+=xincr;
		}
		q+=SCREENWIDTH;		
		yofs+=yincr;
	}

}