
#include <PalmOS.h>
#include <PCENativeCall.h>
#include <PNOLoader.h>
#include <VfsMgr.h>
#include <PalmOSGlue.h>
#include "AppRsc.h"
#include "host68k.h"
#include "pnobridge.h"
#include "palm5way.h"
#include "ydkmain68k.h"

#include "endianutils.h"

#include "zodiac.h"


#include <TwChars.h>

#include <68k/System/HsExt.h>
#include <Common/System/HsKeyTypes.h>


UInt8 g_paused = 0;
UInt8 g_frameskip = 2;
UInt32 g_bigalloc = 0;
extern zdoomz_pref_t g_zdoomz_pref;

UInt16 palm_vfs_count ( void ) {
  UInt16 volref = 0;
  UInt32 voliter = vfsIteratorStart;
  UInt16 count = 0;

  if ( VFSVolumeEnumerate ( &volref,  &voliter ) != errNone ) {
    return ( 0 ); // error
  }

  count = 1;

  while ( VFSVolumeEnumerate ( &volref,  &voliter ) == errNone ) {
    //if ( voliter != vfsIteratorStop ) {
    count++;
    //}
  }

  return ( count );
}

UInt16 palm_vfs_iter ( char *path ) {
  UInt16 volref = 0;
  UInt32 voliter = vfsIteratorStart;
  FileRef file;
  UInt16 firstvolref;

  // can we enumerate at all?
  if ( VFSVolumeEnumerate ( &volref,  &voliter ) != errNone ) {
    return ( 0 );
  }

  // store first succeeding volume
  firstvolref = volref;

  // can we open our file? If so, we found our file :)
  if ( VFSFileOpen ( volref, path, vfsModeRead, &file ) == errNone ) {
    VFSFileClose ( file );
    return ( volref );
  }

  // look through other volumes, trying to find our file
  while ( VFSVolumeEnumerate ( &volref,  &voliter ) == errNone ) {

    if ( VFSFileOpen ( volref, path, vfsModeRead, &file ) == errNone ) {
      VFSFileClose ( file );
      return ( volref );
    }

  }

  //return ( voliter );
  return ( firstvolref );
}

void *hw_query_vram ( void ) {
  WinHandle winh;
  BitmapType *winb;

  winh = WinGetDisplayWindow();
  winb = WinGetBitmap ( winh );

  return ( BmpGetBits ( winb ) );
}

/* set screen to 16bpp mode */
UInt8 hw_set16bpp ( void ) {
  UInt32 depth = 16;
  Boolean colp = true;

  if ( WinScreenMode ( winScreenModeSet, NULL, NULL, &depth, &colp ) 
         != errNone )
  {
    return ( 0 );
  }

  return ( 1 );
}

int update_field ( FormPtr f, int obid, char *newtext ) {
  MemHandle newhandle, oldhandle;
  FieldPtr field;

  newhandle = MemHandleNew ( StrLen ( newtext ) + 1 );

  if ( ! newhandle ) {
    return ( 0 );
  }

  StrCopy ( MemHandleLock ( newhandle ), newtext );
  MemHandleUnlock ( newhandle );

  field = FrmGetObjectPtr ( f, FrmGetObjectIndex ( f, obid ) );

  oldhandle = FldGetTextHandle ( field );

  FldSetTextHandle ( field, newhandle );

  if ( oldhandle ) {
    MemHandleFree ( oldhandle );
  }

  return ( 1 );
}

UInt32 pnobridge_retval = 0;
UInt32 pnobridge_mask = 0;

UInt32 host_event_handler ( UInt32 arg, UInt32 arg2 ) {
  UInt8 f;
//  UInt32 a;
  static UInt32 accum = 0;

  // clear retval
  pnobridge_retval = 0;

  // normalize args
//  f = arg & BRIDGEMASK;
//  a = arg >> BRIDGESHIFT;
	f = arg;

  if ( f == BRIDGE_MemGluePtrNew ) 
  {   
    pnobridge_retval = (UInt32) MemGluePtrNew ( (UInt32)arg2 );
  } 
  else if ( f == BRIDGE_bigalloc ) 
  {
    pnobridge_retval = (UInt32) MemGluePtrNew ( 0x400000 );
    //pnobridge_retval = (UInt32) MemPtrNewL ( 0x400000 );
    g_bigalloc = pnobridge_retval;

  } 
  else if ( f == BRIDGE_zodiacblit ) {
  	hostcall_t *data;
  	data=(hostcall_t*)arg2;      
    if ( data->a == 0 ) {
      pnobridge_retval = tw_gfx_lock();
      if ( ! pnobridge_retval ) {
		DEBUGS ( "Couldn't lock display surface!" );
      }
    }else if ( data->a == 1 ) {
      tw_gfx_unlock();
    }else if (data->a == 2) {
  	  tw_gfx_blit(data->b,data->c);
  	}else if (data->a == 3) {
	  tw_gfx_blit2(data->b,data->c,data->d);
  	}   
  } else if ( f == BRIDGE_bigfree ) 
  {
    MemPtrFree ( (void*) g_bigalloc );
    g_bigalloc = 0;
  } 
  else if ( f == BRIDGE_progress ) 
  {
//    WinDrawLine ( 0, 158, a * 160 / 10, 158 );
//    WinDrawLine ( 0, 159, a * 160 / 10, 159 );
  } else if ( f == BRIDGE_debugu32 ) 
  {
    //DEBUGU32(a);
  } else if ( f == BRIDGE_printfu32 ) 
  {
//    char b [ 40 ];
//    StrPrintF ( b, "%lu", a );
//    WinDrawChars ( b, StrLen ( b ), 0, 0 );
  } else if ( f == BRIDGE_accum ) 
  {
//    accum = a;
  } else if ( f == BRIDGE_setaudio ) 
  {
    /*UInt32 poop = ( accum << 16 ) | a;
    hostcall_t *h = (hostcall_t*) poop;
    audio_begin ( (void*) h -> a, true, (void*) h -> b );*/
  } else if ( f == BRIDGE_debugs ) 
  {
//    UInt32 poop = ( accum << 16 ) | a;
//    char *p = (char*)poop;
    //DEBUGS(p);
  } else if ( f == BRIDGE_printfs ) 
  {
  //  UInt32 poop = ( accum << 16 ) | a;
//    char *p = (char*)poop;
//    WinDrawChars ( p, StrLen ( p ), 0, 0 );
  } else if ( f == BRIDGE_get_skip ) 
  {
    pnobridge_retval = g_frameskip;
  } else if ( f == BRIDGE_error )   {
    //DEBUGS ( "error" );
    /*
     * BRIDGE COMMANDS HERE
     */

  } else if ( f == BRIDGE_SndStreamCreate )  {
  	bighostcall_t *data;
  	data=(bighostcall_t*)arg2;
  	
  	pnobridge_retval=SndStreamCreate((SndStreamRef*)(data->a),
  					(SndStreamMode)(data->b),
  					(UInt32)(data->c),
  					(SndSampleType)(data->d),
  					(SndStreamWidth)(data->e),
  					(SndStreamBufferCallback)(data->f),
  					(void *)(data->g),
  					(UInt32)(data->h),
  					(Boolean)(data->i)
  					);
	
  }else if ( f == BRIDGE_SndStreamStart )  {
  	pnobridge_retval=SndStreamStart((SndStreamRef)arg2);
  }else if ( f == BRIDGE_SndStreamStop )  {
  	pnobridge_retval=SndStreamStop((SndStreamRef)arg2);
  }else if ( f == BRIDGE_SndStreamDelete )  {
  	pnobridge_retval=SndStreamDelete((SndStreamRef)arg2);
  }else if ( f == BRIDGE_SndStreamGetVolume )  {
  	hostcall_t *data;
  	data=(hostcall_t*)arg2;  	
  	pnobridge_retval=SndStreamGetVolume((SndStreamRef)(data->a),
  				(Int32*)(data->b));
  } else if ( f == BRIDGE_SndStreamSetVolume )  {
  	hostcall_t *data;
  	data=(hostcall_t*)arg2;  	
  	pnobridge_retval=SndStreamSetVolume((SndStreamRef)(data->a),
  				(Int32)(data->b));
  } else if ( f == BRIDGE_Fullscreen )  {
  	hw_set_FullscreenGraf((UInt32)arg2);
  } else if (f == BRIDGE_consoleCmd) {
	  if (g_zdoomz_pref.g_fullscreen) {hw_set_FullscreenGraf(0);}

  	  {
  	  FormPtr frmP = FrmInitForm(ConsoleForm);
  	  UInt16 btn = FrmDoDialog(frmP);
  	  if ((btn == ConsoleOKButton) && FldGetTextPtr(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, ConsoleDataField))))
  	     StrCopy((char*) arg2, FldGetTextPtr(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, ConsoleDataField))));
  	  else
  	     ((char*) arg2)[0] = 0;
  	  }
	  
	  if (g_zdoomz_pref.g_fullscreen) {hw_set_FullscreenGraf(1);}
  } else if ( f == BRIDGE_SrmSend )  {
  	hostcall_t *data;
  	data = (hostcall_t*)arg2;
  	
  	pnobridge_retval = SrmSend(data->a,
  					(const void *) data->b,
  					data->c,
  					(Err * ) data->d
  					);
  } else if ( f == BRIDGE_SrmReceive )  {
  	bighostcall_t *data;
  	data = (bighostcall_t*)arg2;
  	
  	pnobridge_retval = SrmReceive(data->a,
  					(void *) data->b,
  					data->c,
  					data->d,
  					(Err *) data->e
  					);
  } else if ( f == BRIDGE_SrmReceiveCheck )  {
  	hostcall_t *data;
  	data=(hostcall_t*)arg2;  	
  	pnobridge_retval = SrmReceiveCheck((SndStreamRef)(data->a),
  				(UInt32*)(data->b));
  }
  else if ( f == BRIDGE_NetLibReceive )
  {
  	bighostcall_t *data;
  	data = (bighostcall_t*)arg2;
  	
  	pnobridge_retval = NetLibReceive(data->a, (NetSocketRef) data->b, (void *) data->c, data->d, data->e, (void *) data->f, (UInt16 *) data->g, data->h, (Err *) data->i);
  }
  else if ( f == BRIDGE_NetLibSend )
  {
  	bighostcall_t *data;
  	data = (bighostcall_t*)arg2;
  	
  	pnobridge_retval = NetLibSend(data->a, (NetSocketRef) data->b, (void *) data->c, data->d, data->e, (void *) data->f, data->g, data->h, (Err *) data->i);
  }
  else if (f == BRIDGE_TwRumble)
  {
  	bighostcall_t *data;
  	data = (bighostcall_t*)arg2;

    tw_rumble(data->a);
  }
  else if (f == BRIDGE_TreoKey)
  {
	UInt32 treokeys[3];
	hostcall_t *data;
	data = (hostcall_t*)arg2;

	HsKeyCurrentStateExt(treokeys);
/*
{
char debug[64];
StrPrintF(debug, "0x%lx 0x%lx 0x%lx", treokeys[0], treokeys[1], treokeys[2]);
WinDrawChars(debug, StrLen(debug), 0, 147);
}
*/
	if (treokeys[1] || treokeys[2])
	{
		if (treokeys[1] & keyBitExt1Q) data->a = 0x80000000 | 'Q';
		else if (treokeys[1] & keyBitExt1W) data->a = 0x80000000 | 'W';
		else if (treokeys[1] & keyBitExt1Z) data->a = 0x80000000 | 'Z';
		else if (treokeys[1] & keyBitExt1U) data->a = 0x80000000 | 'U';
		else if (treokeys[1] & keyBitExt1I) data->a = 0x80000000 | 'I';
		else if (treokeys[1] & keyBitExt1O) data->a = 0x80000000 | 'O';
		else if (treokeys[1] & keyBitExt1P) data->a = 0x80000000 | 'P';
		else if (treokeys[1] & keyBitExt1A) data->a = 0x80000000 | 'A';
		else if (treokeys[1] & keyBitExt1S) data->a = 0x80000000 | 'S';
		else if (treokeys[1] & keyBitExt1H) data->a = 0x80000000 | 'H';
		else if (treokeys[1] & keyBitExt1J) data->a = 0x80000000 | 'J';
		else if (treokeys[1] & keyBitExt1K) data->a = 0x80000000 | 'K';
		else if (treokeys[1] & keyBitExt1L) data->a = 0x80000000 | 'L';
		else if (treokeys[1] & keyBitExt1Y) data->a = 0x80000000 | 'Y';
		else if (treokeys[1] & keyBitExt1B) data->a = 0x80000000 | 'B';
		else if (treokeys[1] & keyBitExt1N) data->a = 0x80000000 | 'N';
		else if (treokeys[1] & keyBitExt1M) data->a = 0x80000000 | 'M';
		else if (treokeys[1] & keyBitExt1Period) data->a = 0x80000000 | '.';
		else if (treokeys[1] & keyBitExt1Space) data->a = 0x80000000 | ' ';
		else if (treokeys[2] & keyBitExt2Symbol) data->a = 0x80000000 | '#';
		else if (treokeys[2] & keyBitExt2Launcher) data->a = 0x80000000 | '@';
		else if (treokeys[2] & keyBitExt2CmdMenu) data->a = 0x80000000 | '-';
		else if (treokeys[2] & keyBitExt2VolumeUp) data->a = 0x80000000 | 0xbb;
		else if (treokeys[2] & keyBitExt2VolumeDown) data->a = 0x80000000 | 0xab;
		else if (treokeys[1] & keyBitExt1E) data->a = 0x80000000 | '1';
		else if (treokeys[1] & keyBitExt1R) data->a = 0x80000000 | '2';
		else if (treokeys[1] & keyBitExt1T) data->a = 0x80000000 | '3';
		else if (treokeys[1] & keyBitExt1D) data->a = 0x80000000 | '4';
		else if (treokeys[1] & keyBitExt1F) data->a = 0x80000000 | '5';
		else if (treokeys[1] & keyBitExt1G) data->a = 0x80000000 | '6';
		else if (treokeys[1] & keyBitExt1X) data->a = 0x80000000 | '7';
		else if (treokeys[1] & keyBitExt1C) data->a = 0x80000000 | '8';
		else if (treokeys[1] & keyBitExt1V) data->a = 0x80000000 | '9';
		else if (treokeys[2] & keyBitExt2Null) data->a = 0x80000000 | '0';

		pnobridge_retval = 1;
	}
  }

  return ( pnobridge_retval );
}

Boolean is_clie(void)
{
	UInt32 val;

	if (!FtrGet(sysFtrCreator, sysFtrNumOEMCompanyID, &val))
	{
		if (val == 'sony' /*sonyHwrOEMCompanyID_Sony*/)
		{
			/* device might be CLIE */
			return true;
		}
	}

	return false; /* not clie */
}

Boolean is_zire72(void)
{
	UInt32 deviceID, companyID;
	Err devErr, compErr;

	devErr = FtrGet(sysFtrCreator, sysFtrNumOEMDeviceID, &deviceID);
	compErr = FtrGet(sysFtrCreator, sysFtrNumOEMCompanyID, &companyID);
	if ((devErr == errNone) && (compErr == errNone))
	{
		if ((companyID == 'Palm') && (deviceID == 'Zi72'))
			return true;
	}
	return false;
}

Boolean has_5way(void)
{
	UInt32 version;
	Err err = FtrGet (navFtrCreator, navFtrVersion, &version);
	
	return ((version >= 0x00010000) && (err == errNone));
}

Boolean is_treo(void)
{
	// check for Treo 600 to use HS extensions
	Boolean bTreo600=false, bTreo650=false;
	UInt32 deviceID, companyID;
	Err devErr, compErr;

	devErr = FtrGet(sysFtrCreator, sysFtrNumOEMDeviceID, &deviceID);
	compErr = FtrGet(sysFtrCreator, sysFtrNumOEMCompanyID, &companyID);
	if ((devErr == errNone) && (compErr == errNone))
	{
		if ((deviceID == 'H201') || (deviceID == 'H101'))
			bTreo600 = true;
		if ((deviceID == 'H202') || (deviceID == 'H102'))
			bTreo650 = true;
	}

	return (bTreo600 || bTreo650);
}

#define memNewChunkFlagNonMovable    0x0200
#define memNewChunkFlagAllowLarge    0x1000  // this is not in the sdk *g*
SysAppInfoPtr 
SysGetAppInfo(SysAppInfoPtr *uiAppPP, SysAppInfoPtr *actionCodeAppPP)
  SYS_TRAP(sysTrapSysGetAppInfo); 

void *MemPtrNewL ( UInt32 size )
{
	SysAppInfoPtr appInfoP;
	UInt16        ownerID;

	ownerID = ((SysAppInfoPtr)SysGetAppInfo(&appInfoP, &appInfoP))->memOwnerID;

	return MemChunkNew ( 0, size, ownerID | memNewChunkFlagNonMovable | memNewChunkFlagAllowLarge );
}

void MemPtrFreeL ( void *p )
{
	MemPtrFree ( p );
}


