#ifndef h_PNOMain_h
#define h_PNOMain_h

#include "pnobridge.h"

//#define ENABLE_ZGRAB 

#ifdef ENABLE_ZGRAB
#define EMPTY_QUEUES()
#define HANDLE_SYSEVT() SysHandleEvent(&myevent);
#else
#define EMPTY_QUEUES() \
		EvtFlushKeyQueue();\
		EvtFlushPenQueue();
#define HANDLE_SYSEVT()		
#endif

#ifdef __PACE__
#define YDK_HANDLE_EVENT(_pause_func) {\
			EventType myevent; \
			for (;;) {\
				if (stub_filter_event(&myevent)) {\
					if (_pause_func) _pause_func(1);\
					stub_handle_sysevent(&myevent);\
					if (_pause_func) _pause_func(0);\
				} else break;\
			}\
		}

#define YDK_HANDLE_EVENT_NOFUNC() {\
			EventType myevent; \
			for (;;) {\
				if (stub_filter_event(&myevent)) {\
					stub_handle_sysevent(&myevent);\
				} else break;\
			}\
		}		
#else
#include "palmos5.h"
#define YDK_HANDLE_EVENT() {\
		EventType myevent; \
		EMPTY_QUEUES() \
		while (SysEventAvail()) {\
		  	SysEventGet(&myevent,0); \
			if (myevent.eType==nilEvent) break; \
			switch (myevent.eType){\
				case appStopEvent:/*if (menu_confirm("Exit ?")) exit_quake=1;*/\
				case keyDownEvent:\
				case keyUpEvent:\
				case keyHoldEvent:\
				case penDownEvent:\
				case penUpEvent:\
				case penMoveEvent:\
				HANDLE_SYSEVT() \
					break;\
				case winExitEvent:\
/*					_pause_func(1);*/\
					break;\
				case winEnterEvent:\
/*				_pause_func(0);*/\
				case frmUpdateEvent:\
				case winDisplayChangedEvent:{\
					WinHandle winh;\
				    BitmapType *winb;\
					winh = WinGetDisplayWindow();\
					winb = WinGetBitmap ( winh );\
					BmpGetDimensions(winb,&display_width,&display_height,&display_pitch);\
					display_pitch>>=1;\
					g_pnobridge -> display_pitch = display_pitch;\
					g_pnobridge -> display_width = display_width;\
					g_pnobridge -> display_height = display_height;\
					g_pnobridge -> vram =(UInt32)BmpGetBits ( winb );\
					ClearScreen();\
					break;}\
				default:{\
/*					_pause_func(1);*/\
					SysHandleEvent(&myevent);\
/*					_pause_func(0);*/\
				}\
			}\
		}\
		}
#define YDK_HANDLE_EVENT_NOFUNC()  {\
		EventType myevent; \
		while ( SysEventAvail()) {\
		  	SysEventGet(&myevent,0); \
			if (myevent.eType==nilEvent) break; \
			switch (myevent.eType){\
				case appStopEvent:/*penDown=1;if (menu_confirm("Exit emulator ?")) result=2;else result=1;*/break;\
				case winEnterEvent:\
				case frmUpdateEvent:\
				case penDownEvent:\
				case penUpEvent:\
				case penMoveEvent:\
				case keyDownEvent:\
				case keyUpEvent:\
				case keyHoldEvent:\
				case winExitEvent:\
				SysHandleEvent(&myevent);break;\
				case winDisplayChangedEvent:{\
					WinHandle winh;\
				    BitmapType *winb;\
					winh = WinGetDisplayWindow();\
					winb = WinGetBitmap ( winh );\
					BmpGetDimensions(winb,&display_width,&display_height,&display_pitch);\
					display_pitch>>=1;\
					g_pnobridge -> display_pitch = display_pitch;\
					g_pnobridge -> display_width = display_width;\
					g_pnobridge -> display_height = display_height;\
					g_pnobridge -> vram =(UInt32)BmpGetBits ( winb );\
					ClearScreen();\
					result=1;penDown=1;\
					break;}\
				default:{\
					SysHandleEvent(&myevent);\
				}\
			}\
		}\
		}  

  

#endif	


#define YDK_CHECK_MENU_ACCESS(_menu_func,_videomode_fullscreen) {\
			EvtGetPen(&penX,&penY,&penDown);\
			penX*=_PEN_ADJUST_FACTORX_;\
			penY*=_PEN_ADJUST_FACTORY_;\
			if (penDown) {\
			 	if ((penY>0)&&(penY<60)&&(penX>display_width-80)&&(penX<display_width)) keys|=BTN_TR;\
				else if ((penY>display_height-60)&&(penY<display_height)&&(penX>display_width-80)&&(penX<display_width)) keys|=BTN_BR;\
				else if ((penY>0)&&(penY<60)&&(penX>0)&&(penX<80)) keys|=BTN_TL;\
				else if ((penY>display_height-60)&&(penY<display_height)&&(penX>0)&&(penX<80)) keys|=BTN_BL;\
				else if ((penX>0)&&(penX<display_width)&&(penY>0)&&(penY<display_height)){\
					WinHandle winh;\
				    BitmapType *winb;\
					stub_fullscreen(0);\
					winh = WinGetDisplayWindow();\
					winb = WinGetBitmap ( winh );\
					BmpGetDimensions(winb,&display_width,&display_height,&display_pitch);\
					display_pitch>>=1;\
					g_pnobridge -> display_pitch = display_pitch;\
					g_pnobridge -> display_width = display_width;\
					g_pnobridge -> display_height = display_height;\
					g_pnobridge -> vram =(UInt32)BmpGetBits ( winb );\
					switch (_menu_func()) {\
						case 1:mStopEmulation=1;break;\
					}\
					if (_videomode_fullscreen) stub_fullscreen(1);\
					winh = WinGetDisplayWindow();\
					winb = WinGetBitmap ( winh );\
					BmpGetDimensions(winb,&display_width,&display_height,&display_pitch);\
					display_pitch>>=1;\
					g_pnobridge -> display_pitch = display_pitch;\
					g_pnobridge -> display_width = display_width;\
					g_pnobridge -> display_height = display_height;\
					g_pnobridge -> vram =(UInt32)BmpGetBits ( winb );\
					ClearScreen();\
				}\
			}	\
		}

#define YDK_WAIT(ms) {\
	int i=GetTickCount();\
	while ((GetTickCount()-i)<ms);\
	}

		
extern UInt32 ticks_per_sec;
extern volatile pnobridge_t *g_pnobridge;
extern const void *g_my_emulStateP;
extern UInt32 display_pitch, display_height, display_width;

void Sys_PrintF( char *s, ...);
void Sys_PrintF2( char *s, ...);

UInt32 host_events ( UInt32 foo );
int rand(void);

Int32 GetTickCount();

/*double cos(double a);
double sin(double a);
double tan(double a);
double atan(double a);
double sqrt(double a);
*/

Err stub_SndStreamCreate(SndStreamRef *channel,	/* channel-ID is stored here */
						SndStreamMode mode,			/* input/output, enum */
						UInt32 samplerate,				/* in frames/second, e.g. 44100, 48000 */
						SndSampleType type,				/* enum, e.g. sndInt16 */
						SndStreamWidth width,			/* enum, e.g. sndMono */
						SndStreamBufferCallback func,	/* function that gets called to fill a buffer */
						void *userdata,					/* gets passed in to the above function */
						UInt32 buffsize);				/* preferred buffersize in frames, not guaranteed, use 0 for default */

Err stub_SndStreamDelete(SndStreamRef channel);
Err stub_SndStreamStart(SndStreamRef channel);
Err stub_SndStreamStop(SndStreamRef channel);
Err stub_SndStreamSetVolume(SndStreamRef channel, Int32 volume);
Err stub_SndStreamGetVolume(SndStreamRef channel, Int32 *volume);
UInt32 stub_SrmSend(UInt16 portId, const void *bufP, UInt32 count, Err *errP);
UInt32 stub_SrmReceive(UInt16 portId, void *rcvBufP, UInt32 count, Int32 timeout, Err *errP);
Err stub_SrmReceiveCheck(UInt16 portId, UInt32 *numBytesP);
UInt32 stubtreokeys(void);
void stub_fullscreen(int fs);
UInt32 stubzodiacblit ( UInt32 mode, UInt32 w,UInt32 h,UInt32 s );
void stubzodiacrumble(UInt32 time);

#endif
