#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"

//#include "AppRsc.h"
#ifdef __PACE__  
#include "PACEInterface.h"
#else
#include "palmos5.h"
#endif


#include "ydk_std.h"

#ifdef YDK_STD_DEBUG
unsigned int ydk_allocated_ptr[65536];//max 65536 pointers
unsigned int ydk_allocated_size[65536];//max 65536 pointers
unsigned int ydk_num_ptr=0;
#endif


void ydk_std_showstat(void)
{
#ifdef YDK_STD_DEBUG
	char str[64],str1[64];
	for (int i=0;i<ydk_num_ptr;i++)
	{				
		StrPrintF(str,"%d %d(%08X)",i,ydk_allocated_ptr[i],ydk_allocated_size[i]);
		menu_message(str);menu_waitPen(NULL, NULL, 1, 0);
//			ydk_free(ydk_allocated_ptr[i]);
	}
//	ydk_num_ptr=0;
#endif	
}


void *ydk_malloc(unsigned int size)
{
	void *ptr;
	ptr=(void*)malloc(size);
#ifdef YDK_STD_ERROR_VERBOSE	
	if (!ptr) {char text[32];menu_info("Out of memory");
	sprintf(text,"Req : %d",size);menu_info(text);}
//	else 	memset(ptr,0,size);
#endif	
#ifdef YDK_STD_DEBUG
	if (ptr)
	{
		ydk_allocated_ptr[ydk_num_ptr]=(unsigned int)ptr;		
		ydk_allocated_size[ydk_num_ptr]=size;		
		ydk_num_ptr++;
	}
	else 
	{
		char str[64],str1[64];
		//StrPrintF(str,"cannot ydk_malloc(%d)",size);
		StrCopy(str,"cannot ydk_malloc ");	
		StrIToA ( str1, size );
		StrCat(str," ");
		StrCat(str,str1);
		menu_message(str); menu_waitPen(NULL, NULL, 1, 0);
	}
#endif	
	
	return ptr;
}
void *ydk_calloc(unsigned int num_elt,unsigned int size_elt)
{
	void *ptr;
	ptr=(void*)malloc(num_elt*size_elt);
	if (ptr) memset(ptr,0,num_elt*size_elt);
#ifdef YDK_STD_ERROR_VERBOSE
	if (!ptr) {menu_message("Out of memory");menu_waitPen(NULL, NULL, 1, 0);}
#endif	
#ifdef YDK_STD_DEBUG
	if (ptr)
	{
		ydk_allocated_ptr[ydk_num_ptr]=(unsigned int)ptr;
		ydk_allocated_size[ydk_num_ptr]=size_elt*num_elt;		
		ydk_num_ptr++;
	}
	else 
	{
		char str[64],str1[64];
		//StrPrintF(str,"cannot ydk_calloc(%d,%d)",num_elt,size_elt);
		StrCopy(str,"cannot ydk_calloc ");	
		StrIToA ( str1, num_elt );
		StrCat(str," ");
		StrCat(str,str1);
		StrIToA ( str1, size_elt );
		StrCat(str," ");
		StrCat(str,str1);
		
		menu_message(str); menu_waitPen(NULL, NULL, 1, 0);
	}
#endif		
	
	return ptr;
}
void ydk_free(void *ptr)
{
#ifdef YDK_STD_DEBUG
	if (ptr)
	{
		int i;
		for (i=0;i<ydk_num_ptr;i++)
			if (ydk_allocated_ptr[i]==(unsigned int)ptr) break;
		if (i<ydk_num_ptr)
		{
			for (int j=i;j<(ydk_num_ptr-1);j++)
			{
				ydk_allocated_ptr[j]=ydk_allocated_ptr[j+1];
				ydk_allocated_size[j]=ydk_allocated_size[j+1];
			}
			
			ydk_num_ptr--;
		}
		else
		{
			char str[64],str1[64];
			//StrPrintF(str,"cannot ydk_free(%08X)",(unsigned int)ptr);
			StrCopy(str,"cannot ydk_free ");	
			StrIToA ( str1, (unsigned int)ptr );
			StrCat(str," ");
			StrCat(str,str1);
			menu_message(str); menu_waitPen(NULL, NULL, 1, 0);
		}
	}
#endif	
	if (ptr) free(ptr);		
}


